"use strict";
// Import here Polyfills if needed. Recommended core-js (npm i -D core-js)
// import "core-js/fn/array.find"
// ...
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContentType = void 0;
var axios_1 = require("axios");
var utils_1 = require("./utils");
var js_base64_1 = require("js-base64");
var ContentType;
(function (ContentType) {
    ContentType["form"] = "application/x-www-form-urlencoded";
    ContentType["json"] = "application/json; charset=utf-8";
    ContentType["multipart"] = "multipart/form-data";
})(ContentType = exports.ContentType || (exports.ContentType = {}));
function https(config) {
    //  headers参数是必须的
    var appId = config.appId, secrect = config.secrect;
    var https = axios_1.default.create(config);
    https.interceptors.request.use(function (config) {
        var headers = config.headers;
        config.headers = __assign(__assign({}, headers), { 'content-type': ContentType.json });
        config.method = 'POST';
        // 对传参进行加密
        // contentType为form时，参数属性名为params
        var params = config.params ? config.params : config.data;
        params = __assign(__assign({}, params), { appId: appId, noStr: utils_1.createRandomStr() });
        var data = __assign(__assign({}, params), { sign: utils_1.encryptSm3(secrect, params) });
        if (config.params) {
            config.params = js_base64_1.Base64.encode(JSON.stringify(data));
        }
        else {
            config.data = js_base64_1.Base64.encode(JSON.stringify(data));
        }
        config.url = config.url + "?characterset=UTF-8";
        return config;
    }, function (error) {
        return Promise.reject(error);
    });
    https.interceptors.response.use(function (response) {
        // 对出参进行解密并比对秘钥
        var data = JSON.parse(js_base64_1.Base64.decode(response.data));
        var sign = data.sign, rest = __rest(data, ["sign"]);
        var realSign = utils_1.encryptSm3(secrect, rest);
        // 首先判断是否有篡改
        if (realSign !== sign) {
            return Promise.reject(new Error('sign不一致'));
        }
        if (data.code === 200) {
            response.data = JSON.parse(data.data);
            return Promise.resolve(JSON.parse(data.data));
            // return response
        }
        else {
            return Promise.reject(data);
        }
    }, function (error) {
        return Promise.reject(error);
    });
    return https;
}
var HBBasicClient = /** @class */ (function () {
    function HBBasicClient(config) {
        this.httpClient = https(config);
    }
    HBBasicClient.prototype.$post = function (url, data) {
        return __awaiter(this, void 0, void 0, function () {
            var resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.httpClient.request({ url: url, data: data })];
                    case 1:
                        resData = _a.sent();
                        return [2 /*return*/, Promise.resolve(resData)];
                }
            });
        });
    };
    return HBBasicClient;
}());
exports.default = HBBasicClient;
//# sourceMappingURL=hb-basic-js-sdk.js.map